//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ^bNV[R|[lg eXgvO
//
//  ԍV[g쐬.LabelCountvpeB(public)𗘗p
//  ԍ̃tHg[Uݒ\ɂĂ
//  unit͈ӎIɍ쐬pvr[tH[̃jbg
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit NumSheetUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBTables, plPrev, plTackPrev, StdCtrls, ComCtrls, ExtCtrls,
  Buttons, plPrevfrm, Spin, Menus, ToolWin;

type
  TNumSheetForm = class(TplPrevForm)
    Panel1: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    FontDialog1: TFontDialog;
    SpeedButton3: TSpeedButton;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    plTackPrev1: TplTackPrev;
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure plTackPrev1FormShow(Sender: TObject);
    procedure plTackPrev1BeforeDataDraw(Sender: TObject; Rect: TRect;
      ACol: Integer; var Text: String);
    procedure plTackPrev1AfterLabelDraw(Sender: TObject; Rect: TRect; ARow,
      ACol, LabelNo: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    FStartNo : Integer;
    FFinalNo : Integer;
  public
    { Public 錾 }
  end;

var
  NumSheetForm: TNumSheetForm;

implementation

{$R *.DFM}

//=============================================================================
//  tH[OnCreateCxg
//=============================================================================
procedure TNumSheetForm.FormCreate(Sender: TObject);
begin
  //sɋIȃv^̐ݒ肪Kvłinherited̑Oōs
  plTackPrev1.plSetPrinter.PaperNumber := DMPAPER_A4;

  //ptH[̏ꍇCOnCreatełinheritedKKv
  //Inherited͌pvr[tH[OnCreate
  inherited;
end;

//=============================================================================
//  TplTackPrevOnFormShowCxg
//  tH[\JnňJnx̍sƃxݒ
//  ̃tH[\̂Previw\bh͕sv
//=============================================================================
procedure TNumSheetForm.plTackPrev1FormShow(Sender: TObject);
begin
  //Jnxs̍ŏlƍőlƏl̐ݒ
  SpinEdit1.MinValue := 1;
  SpinEdit1.MaxValue := plTackPrev1.LabelRowCnt;
  SpinEdit1.Value    := 1;

  //Jnx̍ŏlƍőlƏl̐ݒ
  SpinEdit2.MinValue := 1;
  SpinEdit2.MaxValue := plTackPrev1.LabelColCnt;
  SpinEdit2.Value    := 2;

  //ԍD̔ԍ̐ݒ
  SpinEdit3.MaxLength := 3;
  SpinEdit3.MinValue  := 0;
  SpinEdit3.MaxValue  := 100;
  SpinEdit4.MaxLength := 3;
  SpinEdit4.MinValue  := 1;
  SpinEdit4.MaxValue  := 100;

  SpinEdit3.Value := 1;
  SpinEdit4.Value := 50;

  //Jnx̍sƗw
  plTackPrev1.StartRow := SpinEdit1.Value;
  plTackPrev1.StartCol := SpinEdit2.Value;
  //ԍ̏l
  FStartNo := SpinEdit3.Value;
  FFinalNo   := SpinEdit4.Value;

  //x̖ݒ肵,^bNV[R|̎s
  plTackPrev1.LabelCount := Abs(FFinalNo - FStartNo) + 1;
end;

//=============================================================================
//  TplTackPrevOnBeforePageDrawCxg
//  eŕ\ÕCxg
//  x̃TCYƃx̑Xe[^Xo[ɕ\
//=============================================================================
procedure TNumSheetForm.plTackPrev1BeforeDataDraw(Sender: TObject;
  Rect: TRect; ACol: Integer; var Text: String);
var
  LHorzSizeStr : String;
  LVertSizeStr : String;
  LText        : String;
begin
  LHorzSizeStr := '   ' + Format('%5.1f', [plTackPrev1.LabelWidth  / 10]) + ' mm';
  LVertSizeStr := '  c ' + Format('%5.1f', [plTackPrev1.LabelHeight / 10]) + ' mm';
  LText        := '  @x ' + IntToStr(plTackPrev1.LabelCount) + ' ';

  plTackPrev1.StatusBarText := '  xTCY' + LHorzSizeStr + LVertSizeStr + LText;
end;

//=============================================================================
//  TplTackPrevOnAfterLabelDrawCxg
//  ex`̃Cxg
//  (摜\tĂ̂OnBeforeCxgƕ؂Ă܂)
//  ԍD̔ԍ`悷
//=============================================================================
procedure TNumSheetForm.plTackPrev1AfterLabelDraw(Sender: TObject;
  Rect: TRect; ARow, ACol, LabelNo: Integer);
var
  LabelNumber : Integer;
begin
  //tHg
  plTackPrev1.Canvas.Font.Assign(FontDialog1.Font);

  //TplTackPreṽtHgTCYɕϊ
  plTackPrev1.FontSize(FontDialog1.Font.Size);
  //Jnԍ̕傫ꍇ͋t
  if (FFinalNo < FStartNo) then begin
    LabelNumber := FStartNo - LabelNo+1;
  end else begin
    LabelNumber := FStartNo + LabelNo - 1;
  end;
  plTackPrev1.TextRectCC(Rect.Left,
                         Rect.Right,
                         Rect.Top,
                         Rect.Bottom,
                         IntToStr(LabelNumber));
end;

//=============================================================================
//  SpinEditŐݒ肵eōĕ`
//=============================================================================
procedure TNumSheetForm.SpinEdit1Change(Sender: TObject);
begin
  TSpinEdit(Sender).Enabled := False;

  plTackPrev1.StartRow := SpinEdit1.Value;
  plTackPrev1.StartCol := SpinEdit2.Value;
  FStartNo             := SpinEdit3.Value;
  FFinalNo             := SpinEdit4.Value;

  //쐬郉x̖LabelCountɃZbg
  plTackPrev1.LabelCount := Abs(FFinalNo - FStartNo) + 1;

  //ȏ̐ݒōĕ`
  plTackPrev1.Display(plTackPrev1.PageNumber);
  TSpinEdit(Sender).Enabled := True;
  Application.ProcessMessages;
end;

//=============================================================================
//  [tHgݒ]{^ŃtHgύXĕ`
//=============================================================================
procedure TNumSheetForm.SpeedButton3Click(Sender: TObject);
begin
  if FontDialog1.Execute then begin
    plTackPrev1.Display(plTackPrev1.PageNumber);
  end;
end;

end.
