{$WARNINGS OFF}
//=============================================================================
//  ^bNV[R|[lg
//  R|[lgo^ƃvpeBGfB^֌W
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plTackPrevReg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, ExtDlgs,
  Dialogs, Db, DesignIntf, DesignEditors, Exptintf;

type
  //-----------------------------------------------------------------------------
  //  plTackPreṽJ֌Wp
  //-----------------------------------------------------------------------------
  //FieldNamevpeB̐ݒp
  TFieldNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  //DrawMethodvpeB̐ݒp
  TDrawMethodProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  //摜t@C̃pXp.ImageFilevpeB
  TImageFileProperty = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  //-----------------------------------------------------------------------------
  //  R|[lg̃j[ƃ_uNbNł̓p
  //-----------------------------------------------------------------------------
  TplColumnEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(const PropertyEditor : IProperty;
                           var Continue : Boolean); override;
  public
    procedure ExecuteVerb(Index: Integer);override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TplTackPrevReg = class(TComponent)
  end;

procedure Register;

implementation

uses
    plTackPrev;

{ TFieldNameProperty }

//=============================================================================
//  QueryFieldName̓XgI
//  vOASŎw肵ڂꍇ́CTQueryɊY鍀ڂv
//  ZڂƂė\ߍ쐬ĂD
//=============================================================================
function TFieldNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

//=============================================================================
//  DataSetFieldNamẽXg쐬
//  f[^Zbg(DataSetvpeB)ݒȂ
//=============================================================================
procedure TFieldNameProperty.GetValues(Proc: TGetStrProc);
var
  i       : Integer;
  DataSet : TDataSet;
begin
  DataSet := (GetComponent(0) as TplTackColumn).plTackPrev.DataSet;
  if (Assigned(DataSet)) then begin
    DataSet.Open;
    for i := 0 to DataSet.FieldCount - 1 do begin
      Proc(DataSet.Fields[i].FieldName);
    end;
    DataSet.Close;
  end;
end;

{ TDrawMethodProperty }
//=============================================================================
//  `Ɏgp郁\bhXg̍쐬
//  ٍvr[R|[lg̕`惁\bhI
//  ͔C̋CȂłȂCꂪ킩₷Ĉ?!
//=============================================================================
function TDrawMethodProperty.GetAttributes: TPropertyAttributes;
begin
   Result := [paValueList];
end;

procedure TDrawMethodProperty.GetValues(Proc: TGetStrProc);
begin
  Proc('None');
  Proc('TextOut');
  Proc('TextOutLT');
  Proc('TextOutLC');
  Proc('TextOutLB');
  Proc('TextOutCT');
  Proc('TextOutCC');
  Proc('TextOutCB');
  Proc('TextOutRT');
  Proc('TextOutRC');
  Proc('TextOutRB');
  Proc('TextRectLT');
  Proc('TextRectLC');
  Proc('TextRectLB');
  Proc('TextRectCT');
  Proc('TextRectCC');
  Proc('TextRectCB');
  Proc('TextRectRT');
  Proc('TextRectRC');
  Proc('TextRectRB');
  Proc('TextRectJust');
  Proc('TextRectJustTate');
  Proc('ZipOut');
  Proc('ZipOutEx');
  Proc('TextRectFit');
  Proc('StretchDrawImage');
end;

{ TImageFileSProperty }

//=============================================================================
//  \̂̓_CAO
//=============================================================================
function TImageFileProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

//=============================================================================
//  \摜t@CI_CAO\ImageFilevpeBɃZ
//  bg
//=============================================================================
procedure TImageFileProperty.Edit;
var
  PictDlg: TOpenPictureDialog;
begin
  PictDlg := TOpenPictureDialog.Create(nil);
  if PictDlg.Execute then begin
    SetStrValue(String(PictDlg.FileName));
  end;
  PictDlg.Free;
end;

{ plColumnEditor }

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  VKڐ͂P
//=============================================================================
function TplColumnEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  j[\ڂ̐ݒ
//  ̃R|[lgł͂PDRNVGfB^̋N
//=============================================================================
function TplColumnEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0 : Result := 'J̐ݒ';
  end;
end;

//=============================================================================
//  R|[lgł̉ENbNj[̐ݒ
//  ftHg̃R|[lgGfB^N邾
//=============================================================================
procedure TplColumnEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    //ftHg̃GfB^ďo
    0 : inherited edit;
  end;
end;

//=============================================================================
//  R|[lg̃ftHgGfB^̒`
//  (_uNbN̓)
//=============================================================================
procedure TplColumnEditor.EditProperty(const PropertyEditor : IProperty;
  var Continue: Boolean);
begin
  if CompareText(PropertyEditor.GetName, 'Columns') = 0 then begin
    PropertyEditor.Edit;
    Continue := False;
    Designer.Modified;
  end;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplTackPrev]);
  RegisterPropertyEditor(TypeInfo(String), TplTackColumn,'FieldName', TFieldNameProperty);
  RegisterPropertyEditor(TypeInfo(String), TplTackColumn,'DrawMethod',TDrawMethodProperty);
  RegisterPropertyEditor(TypeInfo(String), TplTackColumn,'ImageFile', TImageFileProperty);

  RegisterComponentEditor(TplTackPrev, TplColumnEditor);
end;

end.
